var ssContactInfo = null;

function ssContactInfoLoad() 
{
  ssContactInfo = new ssContactInfoManager();
  ssContactInfo.init();
}

function ssContactInfoUnload()
{
  ssContactInfo.destroy();
  ssContactInfo = null;
}

function ssContactInfoManager()
{
  return this;
}

ssContactInfoManager.prototype =
{
  init: function()
  {
  	var aDoc = window.arguments[0];
  	
  	debugsc( aDoc );
  	
  	var nameelement = document.getElementById( "searchstatus-alexa-contactinfo-ownername" );
  	var name = aDoc.getElementsByTagName( "OWNER" ).item( 0 ).attributes.getNamedItem( "NAME" ).nodeValue;
  	nameelement.setAttribute( "value", name );
  	
  	var dialog = document.getElementById( "searchstatus-alexa-contactinfo-dialog" );
  	dialog.setAttribute( "title", "Contact Info - " + name );
  	
   	var emailelement = document.getElementById( "searchstatus-alexa-contactinfo-email" );
  	var email = aDoc.getElementsByTagName( "EMAIL" ).item( 0 ).attributes.getNamedItem( "ADDR" ).nodeValue;
  	emailelement.setAttribute( "value", email );
  	
   	var phoneelement = document.getElementById( "searchstatus-alexa-contactinfo-phone" );
   	var phone = "";
  	var phoneNodes = aDoc.getElementsByTagName( "PHONE" );
  	for( i = 0; i < phoneNodes.length; i++ )
		{
  		phone += phoneNodes.item( i ).attributes.getNamedItem( "NUMBER" ).nodeValue;
  		if( i < phoneNodes.length - 1 )
  		{
  			phone += "\n";
  		}
  	}
  	this.setMultilineMessage( phoneelement, phone );	
  	
   	var addresselement = document.getElementById( "searchstatus-alexa-contactinfo-address" );
   	var address = "";
  	var addrNodes = aDoc.getElementsByTagName( "ADDR" );
  	for( var i = 0; i < addrNodes.length; i++ )
		{
  		address += addrNodes.item( i ).attributes.getNamedItem( "STREET" ).nodeValue;
  		address += "\n";
  		address += addrNodes.item( i ).attributes.getNamedItem( "CITY" ).nodeValue;
  		address += "\n";
  		address += addrNodes.item( i ).attributes.getNamedItem( "STATE" ).nodeValue;
  		address += "\n";
  		address += addrNodes.item( i ).attributes.getNamedItem( "ZIP" ).nodeValue;
  		address += "\n";  		  	
  		address += addrNodes.item( i ).attributes.getNamedItem( "COUNTRY" ).nodeValue;
  	}
  	this.setMultilineMessage( addresselement, address );	
	},
	
  destroy: function()
  {
    
  },
  
  setMultilineMessage: function( node, text )
  {
  	var lines = text.split( "\n" );
  	for( var i = 0; i < lines.length; i++ ) 
  	{
		  var descriptionNode = document.createElement( "description" );
		  var linetext = document.createTextNode( lines[i] );
		  descriptionNode.appendChild( linetext );
		  node.appendChild( descriptionNode );  		
		}
  }
};

function sendEmail( item )
{
  var topWindow = getTopWindow();
  var browser = topWindow.document.getElementById( "content" );
  browser.loadURI( "mailto:" + item.value );	
}
  	
function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
}  	
  	
function debugsc( message ) 
{
  var time = new Date();
  var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();

  dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
}