var ssLinkReport = null;

function ssLinkReportLoad() 
{
  ssLinkReport = new ssLinkReportManager();
  ssLinkReport.init();
}

function ssLinkReportUnload()
{
  ssLinkReport.destroy();
  ssLinkReport = null;
}

function ssLinkReportManager()
{
  return this;
}

ssLinkReportManager.prototype =
{
  init: function()
  {
  	var topWindow = getTopWindow();

  	var vbox = document.getElementById( "searchstatus-linkreport-details" );
  	var listbox = document.getElementById( "searchstatus-linkreport-listbox" );

		var total = 0;
		var internal = 0;
		var external = 0;
		var nofollow = 0;
		var externalfollow = 0;
		var secure = 0;

		var url = new String( topWindow._content.document.location );
  	url = url.replace( /http:\/\/(.+?)\/.*$/gi, "$1" ).toLowerCase();

		var tags = topWindow._content.document.getElementsByTagName( "a" );
    for( var i = 0; i < tags.length; i++ )
		{
			var tag = tags.item( i );
			
			if( tag.hasAttribute( "href" ) )
			{
				var href = tag.getAttribute( "href" ).toLowerCase();
				var protocol = href.indexOf( "://" );
				
				var rel = tag.getAttribute( "rel" );
				var nofollowlink = ( rel != null && rel.toLowerCase().indexOf( "nofollow" ) > -1 )
				
				if( protocol > -1 )
				{
					if( href.indexOf( url ) > -1 )
					{
						internal++;
					}
				  else
					{
						external++;
						
						if( nofollowlink == false )
						{
							externalfollow++;
						}
					} 
				}
				else
				{
					internal++;
				}
				
				if( nofollowlink )
				{
					nofollow++;
				} 
				
				if( href.indexOf( "https" ) == 0 )
				{
					secure++;
				} 
				
				total++;
			}
		}		  
				
		this.addRow( listbox, "Total", total );
		this.addRow( listbox, "Internal", internal );
		this.addRow( listbox, "External", external ); 
		this.addRow( listbox, "Followed External", externalfollow ); 
		this.addRow( listbox, "Nofollow", nofollow ); 
		this.addRow( listbox, "Secure", secure );
	},
	
  destroy: function()
  {
    
  },
  
  addRow: function( listbox, name, value )
  {
		var listitem = document.createElement( "listitem" );
		
		var col1 = document.createElement( "listcell" );
		col1.setAttribute( "label", name );
		col1.setAttribute( "class", "text" );
		listitem.appendChild( col1 );
		
		var col2 = document.createElement( "listcell" );
		col2.setAttribute( "label", value );
		col2.setAttribute( "class", "text" );
		listitem.appendChild( col2 );	
		
		listbox.appendChild( listitem );
	},  	
  
  copy: function()
  {
  	var listbox = document.getElementById( "searchstatus-linkreport-listbox" );
  	
  	var listitems = listbox.selectedItems;
  	var copytext = "";
  	
  	for( i = 0; i < listitems.length; i++ )
		{
			var item = listitems[i];

			copytext += item.childNodes.item( 0 ).getAttribute( "label" ) + ": " + item.childNodes.item( 1 ).getAttribute( "label" ) + ": " + item.childNodes.item( 2 ).getAttribute( "label" ) + ": " + item.childNodes.item( 3 ).getAttribute( "label" );
			copytext += "\n";
		}
		
		var str = Components.classes["@mozilla.org/supports-string;1"].createInstance( Components.interfaces.nsISupportsString );
		if( !str )
		{
			return false;
		}
		str.data=copytext;
		
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance( Components.interfaces.nsITransferable );
		if( !trans )
		{
			return false;
		}
		
		trans.addDataFlavor( "text/unicode" );
		trans.setTransferData( "text/unicode", str, copytext.length * 2 );
		
		var clipid=Components.interfaces.nsIClipboard;
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService( clipid );
		if( !clip )
		{
			return false;
		}
		
		clip.setData( trans, null, clipid.kGlobalClipboard );
		
		return true;
  }
};
  	
function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
} 

function debugsl( message ) 
{
  var time = new Date();
  var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();

  dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
}
