function searchstatus()
{
	debugss( "new searchstatus" );
  return this;
}

searchstatus.prototype =
{
	mGoogleLastPR: null,
	mGoogleLastCat: null,
	mGoogleLastURL: null,
	mGooglePRCache: new Array(),
	mGooglePRCacheNa: new Array(),
	mGoogleCatCache: new Array(),
	mGoogleState: true, 
	mGoogleText: false,
	mGoogleRankOnly: true,
	
	mAlexaLastDoc: null,
	mAlexaLastURL: null,
	mAlexaRankCache: new Array(),
	mAlexaRankCacheNa: new Array(),
	mAlexaState: true,
	mAlexaText: false,
	
	mCompeteLastDoc: null,
	mCompeteLastURL: null,
	mCompeteRankCache: new Array(),
	mCompeteRankCacheNa: new Array(),
	mCompeteState: true,
	mCompeteText: false,
	
	mHighlightNofollow: false,
	mHighlightColours: new Array( "255, 255, 160", "160, 255, 160", "160, 255, 255", "255, 160, 255", "255, 160, 160" ),
	mHighlightColourIndex: 0,
	
	mInstallDate: "19700101000000",
	mLocalIP: "127.0.0.1",
	mWords: "",
	
  init: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
    moveBox( branch );

		this.mSearchStatusBar = document.getElementById( "searchstatus-bar" );	

    this.mGoogleRank = document.getElementById( "googlerank-status" );	
    this.mGoogleRankText = document.getElementById( "googlerank-status-text" );	
    this.mGoogleTooltip = document.getElementById( "googlerank-tooltip-value" );
    this.mGoogleLinks = document.getElementById( "googlerank-links" );
    this.mGoogleRelated = document.getElementById( "googlerank-related" );
    this.mGoogleCategory = document.getElementById( "googlerank-category" );
    
    this.mAlexaRank = document.getElementById( "alexarank-status" );	
    this.mAlexaRankText = document.getElementById( "alexarank-status-text" );
  	this.mAlexaTooltip = document.getElementById( "alexarank-tooltip-value" );
  	this.mAlexaRelated = document.getElementById( "alexarank-relatedlinks-menu" );
  	this.mAlexaCategory = document.getElementById( "alexarank-categories-menu" );
  	this.mAlexaIncoming = document.getElementById( "alexarank-incominglinks" );
  	this.mAlexaRelatedPopup = document.getElementById( "alexarank-relatedlinks-popup" );
  	this.mAlexaCategoryPopup = document.getElementById( "alexarank-categories-popup" );
  	this.mAlexaContactInfo = document.getElementById( "alexarank-contactinfo" );

    this.mCompeteRank = document.getElementById( "competerank-status" );	
    this.mCompeteRankText = document.getElementById( "competerank-status-text" );
  	this.mCompeteTooltip = document.getElementById( "competerank-tooltip-value" );
		this.mCompeteVisitors = document.getElementById( "competerank-visitors" );

		if( !branch.prefHasUserValue( "googlerankstatuspref.state" ) )
		{
			branch.setIntPref( "googlerankstatuspref.state", 1 );
		}
		this.mGoogleState = branch.getIntPref( "googlerankstatuspref.state" );   	
		
		if( !branch.prefHasUserValue( "googlerankstatustextpref.state" ) )
		{
			branch.setIntPref( "googlerankstatustextpref.state", 0 );
		}
		this.mGoogleText = branch.getIntPref( "googlerankstatustextpref.state" ); 
		
		if( !branch.prefHasUserValue( "alexarankstatuspref.state" ) )
		{
			branch.setIntPref( "alexarankstatuspref.state", 1 );
		}
		this.mAlexaState = branch.getIntPref( "alexarankstatuspref.state" );			
		
		if( !branch.prefHasUserValue( "alexarankstatustextpref.state" ) )
		{
			branch.setIntPref( "alexarankstatustextpref.state", 0 );
		}
		this.mAlexaText = branch.getIntPref( "alexarankstatustextpref.state" );	

		if( !branch.prefHasUserValue( "competerankstatuspref.state" ) )
		{
			branch.setIntPref( "competerankstatuspref.state", 0 );
		}
		this.mCompeteState = branch.getIntPref( "competerankstatuspref.state" );			
		
		if( !branch.prefHasUserValue( "competerankstatustextpref.state" ) )
		{
			branch.setIntPref( "competerankstatustextpref.state", 0 );
		}
		this.mCompeteText = branch.getIntPref( "competerankstatustextpref.state" );		
		
		if( !branch.prefHasUserValue( "highlightnofollowpref.state" ) )
		{
			branch.setIntPref( "highlightnofollowpref.state", 0 );
		}
		this.mHighlightNofollow = branch.getIntPref( "highlightnofollowpref.state" );			
		
		if( !branch.prefHasUserValue( "installdate" ) )
		{
			var installdate = this.formatDate( new Date(), "yyyyMMddhhmmss" );
			branch.setCharPref( "installdate", installdate );
		}
		this.mInstallDate = branch.getCharPref( "installdate" );

		try
		{
  		var dnsService = Components.classes["@mozilla.org/network/dns-service;1"].getService( Components.interfaces.nsIDNSService );
  		var localname = dnsService.myHostName;
  		var dnsRecord = dnsService.resolve( localname, false );
  		this.mLocalIP = dnsRecord.getNextAddrAsString();
		}
		catch(e)
		{
			//ignore
		}

		if( this.mAlexaState != 0 )
		{
			this.mIPRequest = new XMLHttpRequest();
	    this.mIPRequest.onload = onIPRequestLoad;
	    this.mIPRequest.open( "GET", "http://www.ippages.com/simple/" );
			this.mIPRequest.send( null );
		}
  },
  
  initStatus: function()
  {
  	this.initGoogleStatus();
  	this.initAlexaStatus();
		this.initCompeteStatus();
  	this.initHighlightStatus();
 	},

  resetStatus: function()
  {
    this.resetGoogleStatus();
	  this.resetAlexaStatus();
		this.resetCompeteStatus();
	  this.resetHighlightStatus();
  },
  
  initHighlightStatus: function()
  {
  	if( this.mHighlightNofollow )
  	{
  		debugss( "highlighting..." ); 
  		
  		this.highlightNofollow( true );
  	}

		this.mHighlightColourIndex = 0;
 	},
  
  resetHighlightStatus: function()
  {
  	var highlightnofollow = document.getElementById( "searchstatus-highlightnofollow" );
  	highlightnofollow.setAttribute( "checked", this.mHighlightNofollow ? "true" : "false" );  	
  },
  
  destroy: function()
  {

  },
  
  addZero: function(vNumber)
  { 
    return ( ( vNumber < 10 ) ? "0" : "" ) + vNumber;
  },
        
  formatDate: function( vDate, vFormat )
  { 
    var vDay              = this.addZero( vDate.getDate() ); 
    var vMonth            = this.addZero( vDate.getMonth() + 1 ); 
    var vYearLong         = this.addZero( vDate.getFullYear() ); 
    var vYearShort        = this.addZero( vDate.getFullYear().toString().substring( 3, 4 ) ); 
    var vYear             = ( vFormat.indexOf( "yyyy" ) > -1 ? vYearLong : vYearShort );
    var vHour             = this.addZero( vDate.getHours() ); 
    var vMinute           = this.addZero( vDate.getMinutes() ); 
    var vSecond           = this.addZero( vDate.getSeconds() ); 
    var vDateString       = vFormat.replace( /dd/g, vDay ).replace( /MM/g, vMonth ).replace( /y{1,4}/g, vYear );
    vDateString           = vDateString.replace( /hh/g, vHour ).replace( /mm/g, vMinute ).replace( /ss/g, vSecond );
    
    return vDateString;
  },
  
	setLocalIP: function()
	{
		var temp = this.mIPRequest.responseText;

  	var foo = temp.match(/([\d\.]+) /i);
		if( foo )
		{
			this.mLocalIP = foo[1];
			debugss( this.mLocalIP );
		}
	},

  showBackwardLinks: function( item, engine, pagespecific, includeinternal )
  {
  	var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
  	var rootdomain = getRootDomain( currdomain );  
  	var querylink = ( pagespecific ? currurl : rootdomain );

  	if( engine == "google" || engine == "all" )
  	{
  		var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "link:" + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoo" || engine == "all" )
  	{
  		var querystring = "http://search.yahoo.com/search?p=" + ssUrlEncode( ( pagespecific ? "link:" : "linkdomain:" ) + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "msn" || engine == "all" )
  	{
  		var querystring = "http://search.msn.com/results.aspx?q=" + ssUrlEncode( ( pagespecific ? "link:" : "linkdomain:" ) + querylink ) + ( includeinternal ? "" : "+" + ssUrlEncode( "-site:" + rootdomain ) );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}  	
 	},
  
  showIndexedPages: function( item, engine )
  {
  	var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
  	var rootdomain = getRootDomain( currdomain );  	
  	
  	if( engine == "google" || engine == "all" )
  	{
  		var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "site:" + rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "yahoo" || engine == "all" )
  	{
  		var querystring = "http://search.yahoo.com/search?p=" + ssUrlEncode( "site:" + rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}
  	if( engine == "msn" || engine == "all" )
  	{
  		var querystring = "http://search.msn.com/results.aspx?q=" + ssUrlEncode( "site:" + rootdomain );
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
  	}  	
 	},
 	
 	showMetadata: function( item )
 	{
		window.openDialog( "chrome://searchstatus/content/metadata.xul", "searchstatus-metadata-dialog", "centerscreen,chrome,modal,resizable" );	
 	},
 	
 	highlightKeyword: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to highlight:', '' );
 		}
 		
 		if( selection != null )
 		{
			this.highlightSearchTerms( window._content.document, selection );
		}
 	},  	
 	
 	showKeywordDensity: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to match on:', '' );
 		}

		if( selection != null )
 		{
			this.highlightSearchTerms( window._content.document, selection );
 		
			window.openDialog( "chrome://searchstatus/content/kdreport.xul", "searchstatus-kdreport-dialog", "centerscreen,chrome,modal,resizable", selection );	
		}
 	}, 	
 	
 	showLinkReport: function( item )
 	{
		window.openDialog( "chrome://searchstatus/content/linkreport.xul", "searchstatus-linkreport-dialog", "centerscreen,chrome,modal,resizable" );	
 	}, 	 	
 	
 	showWhois: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );

		var querystring = "http://www.whois-search.com/whois/" + currdomain;

		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  
		if( branch.prefHasUserValue( "searchstatus.whoissource" ) )
		{
			if( branch.getIntPref( "searchstatus.whoissource" ) == 1 )
			{
				querystring = "http://whois.domaintools.com/" + currdomain;
			}
			else if( branch.getIntPref( "searchstatus.whoissource" ) == 2 )
			{
				querystring = "http://www.dnsstuff.com/tools/whois.ch?ip=" + currdomain;
			}
		}

  	item.value = querystring;
  	ssOpenItemUrl( item );
 	},
 	
 	showArchive: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );

		var querystring = "http://web.archive.org/web/*/http://" + currdomain;
  	item.value = querystring;
  	ssOpenItemUrl( item );
 	}, 	 	
 	
 	showRobotsTxt: function( item )
 	{
 		var currurl = this.mGoogleLastURL;
  	var currdomain = currurl.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );	

		var querystring = "http://" + currdomain + "/robots.txt";
  	item.value = querystring;
  	ssOpenItemUrl( item );		
 	},

  initGoogleStatus: function() 
  { 
  	var url = window._content.document.location.toString();
  	//url = url.replace( /\?.*$/g, "?" );

  	var reqgr = "info:" + url;
  	var reqgre = "info:" + ssUrlEncode( url ).replace( /_/, "%5F" );
  	this.mGoogleCH = gGoogleCHCalc.googleCH( gGoogleCHCalc.strord( reqgr ) );
  	this.mGoogleCH = "6" + gGoogleCHCalc.googleNewCh( this.mGoogleCH );

  	var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
  	querystring += "toolbarqueries.google.com/search?client=navclient-auto&ch=" + 
  	               this.mGoogleCH + "&ie=UTF-8&oe=UTF-8&features=Rank" + 
  	               ( this.mGoogleRankOnly ? "" : ":FVN" ) + "&q=" + reqgre;
  	
    var pattern = /^http:/;	
  	var pattern2 = /^http:\/\/.*google\..*\/(search|images|groups|news).*/;
  	var pattern3 = /^http:\/\/.*\..*/;
    var pattern4 = /^http:\/\/(127\.|10\.|192\.168).*/; //local ip
  
    var urlIndex = 0;

		debugss( "For google url " + url + ": " + getArrayIndex( this.mGooglePRCache, this.mGoogleCH ) + ", " + getArrayIndex( this.mGooglePRCacheNa, this.mGoogleCH ) );

  	if( this.mGoogleState == 0 )
    {
  		//this.mGoogleRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mGoogleText == 0 )
  		{ 
  			this.mGoogleRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mGoogleRankText.setAttribute( "hidden", "false" );
  		}
  		
  		if( !pattern.test( url ) || pattern2.test( url ) || !pattern3.test( url ) || pattern4.test( url ) || this.isPrivateSite( url ) )
  		{
  			this.mGoogleRank.setAttribute( "status", "" );
  			this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  			this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
  			this.mGoogleLinks.setAttribute( "disabled", "true" );
  			this.mGoogleRelated.setAttribute( "disabled", "true" );
  			this.mGoogleCategory.setAttribute( "disabled", "true" );
  			this.mGoogleLastPR = -1;
  		}
  		else if( ( urlIndex = getArrayIndex( this.mGooglePRCache, this.mGoogleCH ) ) >= 0 )
  	  {
  	    this.mGoogleLastPR = this.mGooglePRCache[urlIndex][1];
  	    this.mGoogleLastCat = this.mGoogleCatCache[urlIndex][1];
  	    this.mGoogleRank.setAttribute( "status", ( this.mGoogleLastCat == "n/a" ? "" : "c" ) + this.mGoogleLastPR );
  	    this.mGoogleRankText.setAttribute( "label", "PageRank: " + this.mGoogleLastPR + "/10" + ( this.mGoogleLastCat == "n/a" ? "" : "*" ) );
  	    this.mGoogleTooltip.setAttribute( "value", "PageRank: " + this.mGoogleLastPR + "/10" );
  	    this.mGoogleLinks.setAttribute( "disabled", "false" );
  	    this.mGoogleRelated.setAttribute( "disabled", "false" );
  	    this.mGoogleCategory.setAttribute( "disabled", this.mGoogleLastCat == "n/a" ? "true" : "false" );
  	    this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
  	  }
      else if( ( urlIndex = getArrayIndex( this.mGooglePRCacheNa, this.mGoogleCH ) ) >= 0 )
      {
        this.mGoogleLastPR = this.mGooglePRCacheNa[urlIndex][1];
        this.mGoogleLastCat = "n/a";
        this.mGoogleRank.setAttribute( "status", ( this.mGoogleLastCat == "n/a" ? "" : "c" ) + this.mGoogleLastPR );
        this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
        this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
        this.mGoogleLinks.setAttribute( "disabled", "true" );
  	    this.mGoogleRelated.setAttribute( "disabled", "true" );
  	    this.mGoogleCategory.setAttribute( "disabled", "true" );
  	    this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
      }	  
  		else
  		{
  			this.mGoogleRank.setAttribute( "status", "" );
  			this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  			this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
  			this.mGoogleLinks.setAttribute( "disabled", "true" );
  			this.mGoogleRelated.setAttribute( "disabled", "true" );
  			this.mGoogleCategory.setAttribute( "disabled", "true" );			
  			
  			if( querystring != this.mGoogleQuerystring )
  			{
	  			debugss( "asking google..." );
	  			
	  			this.mGoogleRequest = new XMLHttpRequest();
	  	    this.mGoogleRequest.onload = onGoogleRequestLoad;
	  	    this.mGoogleRequest.open( "GET", querystring );
	  	    this.mGoogleRequest.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)" );
	  			this.mGoogleRequest.send( null );
	  			this.mGoogleQuerystring = querystring;
  			}
  		}
  	}
  	
  	this.mGoogleLastURL = url;
  },

  setGoogleStatus: function()
  {	
  	debugss( "setGoogleStatus " + this.mGoogleRequest );
  	
  	var temp = this.mGoogleRequest.responseText;

  	var foo = temp.match(/Rank_.*?:.*?:(\d+)/i);
    
    var pr = (foo) ? foo[1] : "-1";
    var foo2 = temp.match(/FVN_.*?:.*?:(?:Top\/)?([^\s]+)/i);
    var cat = (foo2) ? foo2[1] : "n/a";
  
  	this.mGoogleRank.setAttribute( "status", cat == "n/a" ? pr : "c" + pr );

  	if( pr != -1 )
  	{
			this.mGoogleRankText.setAttribute( "label", "PageRank: " + pr + "/10" + ( cat == "n/a" ? "" : "*" ) );
  		this.mGoogleTooltip.setAttribute( "value", "PageRank: " + pr + "/10" );
  		this.mGoogleLinks.setAttribute( "disabled", "false" );
  		this.mGoogleRelated.setAttribute( "disabled", "false" );
  	}
  	else
  	{
  		this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  		this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );
  		this.mGoogleLinks.setAttribute( "disabled", "true" );
  		this.mGoogleRelated.setAttribute( "disabled", "true" );
  	}
  	
  	this.mGoogleCategory.setAttribute( "disabled", cat == "n/a" ? "true" : "false" );
  	this.mGoogleCategory.setAttribute( "tooltiptext", cat );
  	
  	this.mGoogleLastPR = pr;
  	this.mGoogleLastCat = cat;
  	
  	if( this.mGoogleLastPR != -1 )
  	{
  		this.mGooglePRCache.push( new Array( this.mGoogleCH, this.mGoogleLastPR ) );
  		this.mGoogleCatCache.push( new Array( this.mGoogleCH, this.mGoogleLastCat ) );
  	}
  	else
  	{
  		this.mGooglePRCacheNa.push( new Array( this.mGoogleCH, this.mGoogleLastPR ) );	
  	}
  },
  
  resetGoogleStatus: function()
  {
  	var showgoogle = document.getElementById( "searchstatus-showgooglerank" );
  	showgoogle.setAttribute( "checked", this.mGoogleState ? "true" : "false" );	
  	
  	var showgoogletext = document.getElementById( "googlerank-showtext" );
  	showgoogletext.setAttribute( "checked", this.mGoogleText ? "true" : "false" );	
  	
  	var url = window._content.document.location.toString();
  	url = url.replace( /\?.*$/g, "?" );
  	
  	if( this.mGoogleState == 0 )
  	{
  		this.mGoogleRank.setAttribute( "hidden", "true" );
  		this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	else 
  	{
  		this.mGoogleRank.setAttribute( "hidden", this.mGoogleText ? "true" : "false" );
  		this.mGoogleRankText.setAttribute( "hidden", this.mGoogleText ? "false" : "true" );
  		
  		if( url == this.mGoogleLastURL )
  		{
  			this.mGoogleRank.setAttribute( "status", ( this.mGoogleLastCat == "n/a" ? "" : "c" ) + this.mGoogleLastPR );
  			
  		  if( this.mGoogleLastPR == -1 )
  		  {
  		  	this.mGoogleRankText.setAttribute( "label", "PageRank: unranked" );
  				this.mGoogleTooltip.setAttribute( "value", "PageRank: unranked" );	
  				this.mGoogleLinks.setAttribute( "disabled", "true" );
  				this.mGoogleRelated.setAttribute( "disabled", "true" );
  				this.mGoogleCategory.setAttribute( "disabled", "true" );
  				this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );
  			}
  			else
  			{
  				this.mGoogleRankText.setAttribute( "label", "PageRank: " + this.mGoogleLastPR + "/10" + ( this.mGoogleLastCat == "n/a" ? "" : "*" ) );
  				this.mGoogleTooltip.setAttribute( "value", "PageRank: " + this.mGoogleLastPR + "/10" );
  				this.mGoogleLinks.setAttribute( "disabled", "false" );
  				this.mGoogleRelated.setAttribute( "disabled", "false" );
  				this.mGoogleCategory.setAttribute( "disabled", this.mGoogleLastCat == "n/a" ? "true" : "false" );
  	    	this.mGoogleCategory.setAttribute( "tooltiptext", this.mGoogleLastCat );				
  			}
  		}
  		else
  		{
  		  this.initGoogleStatus();	
  		}
  	}
  },

  showGoogleCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat && cat != "n/a" )
  	{
  		var link = "http://directory.google.com/Top/" + encodeURI( cat + "/" );
  		ssOpenUrl( link );
  	}
  },
  
  showGoogleCache: function( item )
  {
  	var currurl = this.mGoogleLastURL;
  	var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "cache:" + currurl );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },  

  showRelatedLinks: function( item, url )
  {
  	var currurl = ( url == "" ? this.mGoogleLastURL : url );
  	var querystring = "http://www.google.com/search?q=" + ssUrlEncode( "related:" + currurl );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );	
  },
  
  showGoogleTrends: function( item )
 	{
 		var selection = content.window.getSelection().toString();
 		if( selection == null || selection.length == 0 )
 		{
 			var selection = prompt( 'Enter keyphrase to search on:', '' );
 		}
 		
 		if( selection != null )
 		{
	 		var querystring = "http://www.google.com/trends?q=" + ssUrlEncode( selection );
	  	
	  	item.value = querystring;
	  	ssOpenItemUrl( item );
	 	}
 	},  

  switchGoogleState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
  	
  	if( this.mGoogleState == 0 )
  	{
  		branch.setIntPref( "googlerankstatuspref.state", 1 );
  	  this.mGoogleState = 1;
  	  this.mGoogleRank.setAttribute( "hidden", this.mGoogleText ? "true" : "false" );
  	  this.mGoogleRankText.setAttribute( "hidden", this.mGoogleText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "googlerankstatuspref.state", 0 );
  	  this.mGoogleState = 0;
  	  this.mGoogleRank.setAttribute( "hidden", "true" );
  	  this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initGoogleStatus();
  },
  
  switchGoogleTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mGoogleText == 0 )
  	{
  		branch.setIntPref( "googlerankstatustextpref.state", 1 );
  	  this.mGoogleText = 1;
  	  this.mGoogleRank.setAttribute( "hidden", "true" );
  	  this.mGoogleRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "googlerankstatustextpref.state", 0 );
  	  this.mGoogleText = 0;
  	  this.mGoogleRank.setAttribute( "hidden", "false" );
  	  this.mGoogleRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initGoogleStatus();
  },  

  hideGoogleTooltip: function()
  {
  	this.mGoogleRank.setAttribute( "tooltip", "" );
  },
  
  showGoogleTooltip: function()
  {
  	this.mGoogleRank.setAttribute( "tooltip", "googlerank-tooltip" );
  },
 
  initAlexaStatus: function() 
  { 
  	var url = window._content.document.location.toString();
  		
    var pattern = /^http:/;	
    var pattern2 = /^http:\/\/.*\..*/;
    var pattern3 = /^http:\/\/(127\.|10\.|192\.168).*/; //local ip
    
    var urlIndex = 0;
    
   	debugss( "For alexa url " + url + ": " + getArrayIndex( this.mAlexaRankCache, url ) + ", " + getArrayIndex( this.mAlexaRankCacheNa, url ) );

  	if( this.mAlexaState == 0 )
    {
    	//this.mAlexaRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mAlexaText == 0 )
  		{ 
  			this.mAlexaRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mAlexaRankText.setAttribute( "hidden", "false" );
  		}
  		
  		if( !pattern.test( url ) || !pattern2.test( url ) || pattern3.test( url ) || this.isPrivateSite( url ) )
  		{
  			this.mAlexaLastDoc = -1;
  			this.initAlexaFromDoc( this.mAlexaLastDoc );
  		}
  		else if( ( urlIndex = getArrayIndex( this.mAlexaRankCache, url ) ) >= 0 )
  	  {
  	    this.mAlexaLastDoc = this.mAlexaRankCache[urlIndex][1];
  	    this.initAlexaFromDoc( this.mAlexaLastDoc );
  	  }	
  		else if( ( urlIndex = getArrayIndex( this.mAlexaRankCacheNa, url ) ) >= 0 )
  	  {
  	    this.mAlexaLastDoc = this.mAlexaRankCacheNa[urlIndex][1];
  	    this.initAlexaFromDoc( this.mAlexaLastDoc );
  	  }		  
  		else
  		{
  			this.initAlexaFromDoc( -1 );
  			var encodedUrl = ssUrlEncode( url );
  			var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
  			//querystring += "http://data.alexa.com/data/+wQ411en8000lA?cli=10&dat=snba&ver=7.0&cdt=alx_vw%3D20%26wid%3D12206%26act%3D00000000000%26ss%3D1680x1050%26bw%3D964%26t%3D0%26ttl%3D35371%26vis%3D1%26rq%3D4&url=" + encodedUrl;
				//querystring += "aws-beta.amazon.com/onca/xml?Service=AlexaWebInfoService&SubscriptionId=1ASYC6ZNPG2STTW2TXG2&Operation=UrlInfo&ResponseGroup=Rank,Related,ContactInfo&Uip=" + this.mLocalIP + "&Uid=" + this.mInstallDate + "&Url=" + encodedUrl;
				querystring += "xml.alexa.com/data?cli=10&dat=nsa&ver=quirk-searchstatus&uid=" + this.mInstallDate + "&userip=" + this.mLocalIP + "&url=" + encodedUrl;

  			if( querystring != this.mAlexaQuerystring )
  			{
					debugss( "asking alexa..." );
  			
	  			this.mAlexaRequest = new XMLHttpRequest();
	  	    this.mAlexaRequest.onload = onAlexaRequestLoad;
	  	    this.mAlexaRequest.open( "GET", querystring );
	  	    //this.mAlexaRequest.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322; Alexa Toolbar)" );
	  	    //this.mAlexaRequest.setRequestHeader( "If-Modified-Since", "Thu, 26 Aug 2002 08:24:16 GMT" );
	  			this.mAlexaRequest.send( null );
  				this.mAlexaQuerystring = querystring;
  			}
  		}
  	}

  	this.mAlexaLastURL = url;
  },

  setAlexaStatus: function()
  {
  	var aDoc = this.mAlexaRequest.responseXML;
  	debugss( "setAlexaStatus " + aDoc );
  	
  	//if( aDoc.getElementsByTagName( "POPULARITY" ).length == 0 )
  	//{
  	//	aDoc = -1;
  	//}
  	
  	this.initAlexaFromDoc( aDoc );
  	this.mAlexaLastDoc = aDoc;
  	
  	if( aDoc == -1 )
  	{
  		this.mAlexaRankCacheNa.push( new Array( this.mAlexaLastURL, aDoc ) );  		
  	}
  	else
  	{
  		this.mAlexaRankCache.push( new Array( this.mAlexaLastURL, aDoc ) );
  	}
  },

  initAlexaFromDoc: function( aDoc )
  {
  	var len = this.mAlexaRelatedPopup.childNodes.length;
  	for( i = 0; i < len; i++ )
  	{
  		this.mAlexaRelatedPopup.removeChild( this.mAlexaRelatedPopup.childNodes.item( 0 ) );
  	}
  	var len = this.mAlexaCategoryPopup.childNodes.length;
  	for( i = 0; i < len; i++ )
  	{
  		this.mAlexaCategoryPopup.removeChild( this.mAlexaCategoryPopup.childNodes.item( 0 ) );
  	}  	

  	var len = this.mSearchStatusBar.childNodes.length;
  	for( i = 15; i < len; i++ )
  	{
  		this.mSearchStatusBar.removeChild( this.mSearchStatusBar.childNodes.item( 15 ) ); 
  	}

  	if( aDoc == -1 )
  	{
  		this.mAlexaRank.setAttribute( "status", "" );
  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: n/a" );
  		this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: n/a" );
  		this.mAlexaRelated.setAttribute( "label", "Related Links" );
  		this.mAlexaRelated.setAttribute( "disabled", "true" );
  		this.mAlexaCategory.setAttribute( "label", "Categories" );
  		this.mAlexaCategory.setAttribute( "disabled", "true" );
  		this.mAlexaContactInfo.setAttribute( "disabled", "true" );
  	}
  	else
  	{
  		if( aDoc.getElementsByTagName( "POPULARITY" ).length > 0 )
  		{
	  		var rankTextAttr = aDoc.getElementsByTagName( "POPULARITY" ).item( 0 ).attributes.getNamedItem( "TEXT" );
	  		var ar = rankTextAttr.nodeValue;
	  		
	  		this.mAlexaRank.setAttribute( "status", this.getAlexaStatus( ar ) );
	  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: " + ssFormatInteger( ar ) );
	  		this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: " + ssFormatInteger( ar ) );
	  	}
	  	else
	  	{
	  		this.mAlexaRank.setAttribute( "status", "" );
	  		this.mAlexaRankText.setAttribute( "label", "Alexa Rank: n/a" );
  			this.mAlexaTooltip.setAttribute( "value", "Alexa Rank: n/a" );
	  	}

  		var linkNodes = aDoc.getElementsByTagName( "RL" );
  		if( linkNodes.length > 0 )
  		{
  			this.mAlexaRelated.setAttribute( "label", "Related Links (" + linkNodes.length + ")" );
  			this.mAlexaRelated.setAttribute( "disabled", "false" );
  			
  			for( i = 0; i < linkNodes.length; i++ )
  			{
  				var linkNode = linkNodes.item( i );
  				var title = linkNode.attributes.getNamedItem( "TITLE" ).nodeValue;
  				var url = "http://" + linkNode.attributes.getNamedItem( "HREF" ).nodeValue;
  				
  				var item = document.createElement( "menuitem" );
  				item.setAttribute( "label", title );
  				item.setAttribute( "value", url );
  				item.setAttribute( "tooltiptext", url );
  				item.setAttribute( "oncommand", "ssOpenItemUrl(event.target);" );
  		
  				this.mAlexaRelatedPopup.appendChild( item );
  				
  				if( this.isRelatedLinksOnBar() )
  				{
	  				var rlPanel = document.createElement( "statusbarpanel" );
			
	  				rlPanel.setAttribute( "label", ( title.length > 10 ? title.substring( 0, 10 ) + "..." : title ) );
	  				rlPanel.setAttribute( "value", url );
	  				rlPanel.setAttribute( "tooltiptext", title + " - " + url );
	  				rlPanel.setAttribute( "statustext", url );
	  				rlPanel.setAttribute( "onclick", "ssOpenUrl(event.target.getAttribute('statustext'));" );
	  				
						this.mSearchStatusBar.appendChild( rlPanel );
					}
  			}
  		}
  		else
  		{
  			this.mAlexaRelated.setAttribute( "label", "Related Links" );
  			this.mAlexaRelated.setAttribute( "disabled", "true" );
  		}
  		
  		var categoryNodes = aDoc.getElementsByTagName( "CAT" );
  		if( categoryNodes.length > 0 )
  		{
  			this.mAlexaCategory.setAttribute( "label", "Categories (" + categoryNodes.length + ")" );
  			this.mAlexaCategory.setAttribute( "disabled", "false" );
  			for( i = 0; i < categoryNodes.length; i++ )
  			{
  				var categoryNode = categoryNodes.item( i );
  				var title = categoryNode.attributes.getNamedItem( "TITLE" ).nodeValue;
  				var path = categoryNode.attributes.getNamedItem( "ID" ).nodeValue;
  				
  				var catmenu = document.createElement( "menu" );
  				catmenu.setAttribute( "label", title );
  				catmenu.setAttribute( "value", path );
  				catmenu.setAttribute( "tooltiptext", path );
  				
  				var catpopup = document.createElement( "menupopup" );
  				var catalexaitem = document.createElement( "menuitem" );
  				catalexaitem.setAttribute( "label", "Alexa" );
  				catalexaitem.setAttribute( "value", path );
  				catalexaitem.setAttribute( "tooltiptext", path );
  				catalexaitem.setAttribute( "oncommand", "gSearchstatus.showAlexaCategory(event.target);" );
  				catpopup.appendChild( catalexaitem );
  				
  				var catdmozitem = document.createElement( "menuitem" );
  				catdmozitem.setAttribute( "label", "DMOZ" );
  				catdmozitem.setAttribute( "value", path );
  				catdmozitem.setAttribute( "tooltiptext", path );
  				catdmozitem.setAttribute( "oncommand", "gSearchstatus.showDMOZCategory(event.target);" );  				
  				catpopup.appendChild( catdmozitem );
  				
  				catmenu.appendChild( catpopup );
  				
  				this.mAlexaCategoryPopup.appendChild( catmenu );
  			}
  			
  			if( this.mAlexaRank.getAttribute( "status" ).length > 0 )
  			{
  				this.mAlexaRank.setAttribute( "status", "c" + this.getAlexaStatus( ar ) );
  				this.mAlexaRankText.setAttribute( "label", "Alexa Rank: " + ssFormatInteger( ar ) + "*" );
  			}
  		}
  		else
  		{
  			this.mAlexaCategory.setAttribute( "label", "Categories" );
  			this.mAlexaCategory.setAttribute( "disabled", "true" );
  		}  		

			var contactinfo = ( aDoc.getElementsByTagName( "OWNER" ).length > 0 );
			this.mAlexaContactInfo.setAttribute( "disabled", contactinfo ? "false" : "true" );
  	}
  },

  getAlexaStatus: function( ar )
  {
  	if( ar < 0 )
  	{
  		return 0;
  	}
  	
  	var rank = Math.log( ar ) / Math.log( 5 );
  	rank = Math.floor( rank );
  	if( rank > 10 )
  	{
  		rank = 10;	
  	}
  	
  	return ( 10 - rank );
  },

  resetAlexaStatus: function()
  {
  	var showalexa = document.getElementById( "searchstatus-showalexarank" );
  	showalexa.setAttribute( "checked", this.mAlexaState ? "true" : "false" );
  	
  	var showalexatext = document.getElementById( "alexarank-showtext" );
  	showalexatext.setAttribute( "checked", this.mAlexaText ? "true" : "false" );	  	
  	
  	var url = window._content.document.location.toString();
  	
  	if( this.mAlexaState == 0 )
  	{
    	this.mAlexaRank.setAttribute( "hidden", "true" );
    	this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	else
  	{
  		this.mAlexaRank.setAttribute( "hidden", this.mAlexaText ? "true" : "false" );
  		this.mAlexaRankText.setAttribute( "hidden", this.mAlexaText ? "false" : "true" );
  		
  		if( url == this.mAlexaLastURL )
  		{
  			this.initAlexaFromDoc( this.mAlexaLastDoc );
  		}
  		else
  		{
  		  this.initAlexaStatus();	
  		}
  	}
  },
	
	getDomain: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
	},
	
	getDomainAndPath: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /http:\/\/(.+)$/gi, "$1" );
	},

	getDomainUrl: function()
	{
		var url = new String( window._content.document.location );
  	return url.replace( /http:\/\/(.+?)\/.*$/gi, "http://$1/" );
	},

  switchAlexaState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mAlexaState == 0 )
  	{
  		branch.setIntPref( "alexarankstatuspref.state", 1 );
  	  this.mAlexaState = 1;
  	  this.mAlexaRank.setAttribute( "hidden", this.mAlexaText ? "true" : "false" );
  		this.mAlexaRankText.setAttribute( "hidden", this.mAlexaText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "alexarankstatuspref.state", 0 );
  	  this.mAlexaState = 0;
  	  this.mAlexaRank.setAttribute( "hidden", "true" );
  	  this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initAlexaStatus();
  },
  
  switchAlexaTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mAlexaText == 0 )
  	{
  		branch.setIntPref( "alexarankstatustextpref.state", 1 );
  	  this.mAlexaText = 1;
  	  this.mAlexaRank.setAttribute( "hidden", "true" );
  	  this.mAlexaRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "alexarankstatustextpref.state", 0 );
  	  this.mAlexaText = 0;
  	  this.mAlexaRank.setAttribute( "hidden", "false" );
  	  this.mAlexaRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initAlexaStatus();
  },

  hideAlexaTooltip: function()
  {
  	this.mAlexaRank.setAttribute( "tooltip", "" );
  },
  
  showAlexaTooltip: function()
  {
  	this.mAlexaRank.setAttribute( "tooltip", "alexarank-tooltip" );
  },

  showIncomingLinks: function( item )
  {
  	var currdomain = this.mAlexaLastURL.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
  	var querystring = "http://www.alexa.com/data/ds/linksin?q=" + ssUrlEncode( "link:" + currdomain ) + "&url=" + ssUrlEncode( this.mAlexaLastURL );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },
  
  showAlexaOverview: function( item )
  {										
  	var currdomain = this.mAlexaLastURL.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
  	var querystring = "http://www.alexa.com/data/details/main?q=&url=" + ssUrlEncode( currdomain );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },
  
  showAlexaTrafficDetails: function( item )
  {
  	var currdomain = this.mAlexaLastURL.replace( /http:\/\/(.+?)\/.*$/gi, "$1" );
  	var querystring = "http://www.alexa.com/data/details/traffic_details?q=&url=" + ssUrlEncode( currdomain );
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },
  

  showAlexaCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat )
  	{
  		var link = "http://www.alexa.com/browse_redirect?catpath=" + cat;
  		ssOpenUrl( link );
  	}
  },  
  
  showDMOZCategory: function( item )
  {
  	var cat = item.getAttribute( "tooltiptext" );
  	if( cat )
  	{
  		var link = "http://dmoz.org/" + cat.substr( 4 );
  		ssOpenUrl( link );
  	}
  }, 
  
	showContactInfo: function( item )
	{
		var contactInfo = window.openDialog( "chrome://searchstatus/content/contactinfo.xul", "searchstatus-alexa-contactinfo-dialog" + this.mAlexaLastDoc.getElementsByTagName( "OWNER" ).item( 0 ).attributes.getNamedItem( "NAME" ).nodeValue, "centerscreen,chrome,modal", this.mAlexaLastDoc );
	},
  
	isPrivateSite: function( url )
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
		
		if( branch.prefHasUserValue( "searchstatus.privatesites" ) )
		{
			var sitestring = branch.getCharPref( "searchstatus.privatesites" );
			var sites = sitestring.split( "," );
			
			var lowerurl = url.toLowerCase();
			for( var i = 0; i < sites.length; i++ )
			{
				if( sites[i].length > 0 && lowerurl.indexOf( sites[i].toLowerCase() ) > -1 )
				{
					debugss( url + " matches private site " + sites[i] + ", ignoring" );
					return true;
				}
			}
		}
		
		return false;
	}, 
	
	isRelatedLinksOnBar: function()
	{
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
		
		if( branch.prefHasUserValue( "searchstatus.relatedlinksonbar" ) )
		{
			return branch.getBoolPref( "searchstatus.relatedlinksonbar" );
		}
		
		return false;
	}, 
  
  initCompeteStatus: function() 
  { 
  	var url = window._content.document.location.toString();
  		
    var pattern = /^http:/;	
    var pattern2 = /^http:\/\/.*\..*/;
    var pattern3 = /^http:\/\/(127\.|10\.|192\.168).*/; //local ip
    
    var urlIndex = 0;
    
   	debugss( "For compete url " + url + ": " + getArrayIndex( this.mCompeteRankCache, url ) + ", " + getArrayIndex( this.mCompeteRankCacheNa, url ) );

  	if( this.mCompeteState == 0 )
    {
    	//this.mCompeteRank.setAttribute( "hidden", "true" );
    }
  	else
  	{
  		if( this.mCompeteText == 0 )
  		{ 
  			this.mCompeteRank.setAttribute( "hidden", "false" );
  		}
  		else
  		{
  			this.mCompeteRankText.setAttribute( "hidden", "false" );
  		}
  		
  		if( !pattern.test( url ) || !pattern2.test( url ) || pattern3.test( url ) || this.isPrivateSite( url ) )
  		{
  			this.mCompeteLastDoc = -1;
  			this.initCompeteFromDoc( this.mCompeteLastDoc );
  		}
  		else if( ( urlIndex = getArrayIndex( this.mCompeteRankCache, url ) ) >= 0 )
  	  {
  	    this.mCompeteLastDoc = this.mCompeteRankCache[urlIndex][1];
  	    this.initCompeteFromDoc( this.mCompeteLastDoc );
  	  }	
  		else if( ( urlIndex = getArrayIndex( this.mCompeteRankCacheNa, url ) ) >= 0 )
  	  {
  	    this.mCompeteLastDoc = this.mCompeteRankCacheNa[urlIndex][1];
  	    this.initCompeteFromDoc( this.mCompeteLastDoc );
  	  }		  
  		else
  		{
  			this.initCompeteFromDoc( -1 );
				var strippedUrl = url.replace( /http:\/\/(.+)$/gi, "$1" );
  			var encodedUrl = ssUrlEncode( strippedUrl );
  			var querystring = this.isAnonymize() ? "http://www.anonymization.org/-" : "http://";
				//querystring += "api.compete.com/fast-cgi/MI?d=" + encodedUrl + "&ver=3&apikey=8am9my8a549a6gm8zqkyjg42&size=small";
				querystring += "dcs.consumerinput.com/fast-cgi/MI?ver=3ss&userid=" + this.mInstallDate + "&registrar=searchstatus&d=" + encodedUrl;

  			if( querystring != this.mCompeteQuerystring )
  			{
					debugss( "asking compete..." );
  			
	  			this.mCompeteRequest = new XMLHttpRequest();
	  	    this.mCompeteRequest.onload = onCompeteRequestLoad;
	  	    this.mCompeteRequest.open( "GET", querystring );
	        this.mCompeteRequest.setRequestHeader( "Accept-Encoding", "none" );
	  			this.mCompeteRequest.send( null );
  				this.mCompeteQuerystring = querystring;
  			}
  		}
  	}

  	this.mCompeteLastURL = url;
  },

  setCompeteStatus: function()
  {
  	var aDoc = this.mCompeteRequest.responseXML;
  	debugss( "setCompeteStatus " + aDoc );
  	
  	//if( aDoc.getElementsByTagName( "POPULARITY" ).length == 0 )
  	//{
  	//	aDoc = -1;
  	//}
  	
  	this.initCompeteFromDoc( aDoc );
  	this.mCompeteLastDoc = aDoc;
  	
  	if( aDoc == -1 )
  	{
  		this.mCompeteRankCacheNa.push( new Array( this.mCompeteLastURL, aDoc ) );  		
  	}
  	else
  	{
  		this.mCompeteRankCache.push( new Array( this.mCompeteLastURL, aDoc ) );
  	}
  },

  initCompeteFromDoc: function( aDoc )
  {
  	if( aDoc == -1 )
  	{
  		this.mCompeteRank.setAttribute( "status", "" );
  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: n/a" );
  		this.mCompeteTooltip.setAttribute( "value", "Compete Rank: n/a" );
			this.mCompeteVisitors.setAttribute( "label", "Show Visitors" );
			this.mCompeteVisitors.setAttribute( "disabled", "true" );
  	}
  	else
  	{
  		if( aDoc.getElementsByTagName( "ranking" ).length > 0 )
  		{
	  		var element = aDoc.getElementsByTagName( "ranking" ).item( 0 );
	  		var cr = element.firstChild.data;
	  		
	  		this.mCompeteRank.setAttribute( "status", this.getCompeteStatus( cr ) );
	  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: " + ssFormatInteger( cr ) );
	  		this.mCompeteTooltip.setAttribute( "value", "Compete Rank: " + ssFormatInteger( cr ) );
	
				if( aDoc.getElementsByTagName( "count" ).length > 0 )
				{
					var countElement = aDoc.getElementsByTagName( "count" ).item( 0 );
					var cc = countElement.firstChild.data;
					this.mCompeteVisitors.setAttribute( "label", "Show Visitors (" + ssFormatInteger( cc ) + ")" );
					this.mCompeteVisitors.setAttribute( "disabled", "false" );
				}
	  	}
	  	else
	  	{
	  		this.mCompeteRank.setAttribute( "status", "" );
	  		this.mCompeteRankText.setAttribute( "label", "Compete Rank: n/a" );
  			this.mCompeteTooltip.setAttribute( "value", "Compete Rank: n/a" );
				this.mCompeteVisitors.setAttribute( "label", "Show Visitors" );
				this.mCompeteVisitors.setAttribute( "disabled", "true" );
	  	}
  	}
  },

  getCompeteStatus: function( ar )
  {
		ar = ar.replace( ",", "" );
	
  	if( ar < 0 )
  	{
  		return 0;
  	}
  	
  	var rank = Math.log( ar ) / Math.log( 5 );
  	rank = Math.floor( rank );
  	if( rank > 10 )
  	{
  		rank = 10;	
  	}
  	
  	return ( 10 - rank );
  },

  resetCompeteStatus: function()
  {
  	var showcompete = document.getElementById( "searchstatus-showcompeterank" );
  	showcompete.setAttribute( "checked", this.mCompeteState ? "true" : "false" );
  	
  	var showcompetetext = document.getElementById( "competerank-showtext" );
  	showcompetetext.setAttribute( "checked", this.mCompeteText ? "true" : "false" );	  	
  	
  	var url = window._content.document.location.toString();
  	
  	if( this.mCompeteState == 0 )
  	{
    	this.mCompeteRank.setAttribute( "hidden", "true" );
    	this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	else
  	{
  		this.mCompeteRank.setAttribute( "hidden", this.mCompeteText ? "true" : "false" );
  		this.mCompeteRankText.setAttribute( "hidden", this.mCompeteText ? "false" : "true" );
  		
  		if( url == this.mCompeteLastURL )
  		{
  			this.initCompeteFromDoc( this.mCompeteLastDoc );
  		}
  		else
  		{
  		  this.initCompeteStatus();	
  		}
  	}
  },

  switchCompeteState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mCompeteState == 0 )
  	{
  		branch.setIntPref( "competerankstatuspref.state", 1 );
  	  this.mCompeteState = 1;
  	  this.mCompeteRank.setAttribute( "hidden", this.mCompeteText ? "true" : "false" );
  		this.mCompeteRankText.setAttribute( "hidden", this.mCompeteText ? "false" : "true" );
  	}
  	else
  	{
  		branch.setIntPref( "competerankstatuspref.state", 0 );
  	  this.mCompeteState = 0;
  	  this.mCompeteRank.setAttribute( "hidden", "true" );
  	  this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initCompeteStatus();
  },
  
  switchCompeteTextState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mCompeteText == 0 )
  	{
  		branch.setIntPref( "competerankstatustextpref.state", 1 );
  	  this.mCompeteText = 1;
  	  this.mCompeteRank.setAttribute( "hidden", "true" );
  	  this.mCompeteRankText.setAttribute( "hidden", "false" );
  	}
  	else
  	{
  		branch.setIntPref( "competerankstatustextpref.state", 0 );
  	  this.mCompeteText = 0;
  	  this.mCompeteRank.setAttribute( "hidden", "false" );
  	  this.mCompeteRankText.setAttribute( "hidden", "true" );
  	}
  	
  	this.initCompeteStatus();
  },

  hideCompeteTooltip: function()
  {
  	this.mCompeteRank.setAttribute( "tooltip", "" );
  },
  
  showCompeteTooltip: function()
  {
  	this.mCompeteRank.setAttribute( "tooltip", "competerank-tooltip" );
  },

  showCompeteSnapshot: function( item )
  {
  	var currdomain = this.getDomain();
  	var querystring = "http://snapshot.compete.com/" + ssUrlEncode( currdomain ) + "?src=3ss";
  	
  	item.value = querystring;
  	ssOpenItemUrl( item );
  },

	isAnonymize: function()
	{
		return false;
		
//		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
//		var branch = preferencesService.getBranch( "extensions.searchstatus." );    	
//		
//		if( branch.prefHasUserValue( "searchstatus.anonymize" ) )
//		{
//			return branch.getBoolPref( "searchstatus.anonymize" );
//		}
//		
//		return false;
	},
	
  switchHighlightNofollowState: function()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.searchstatus." );  	
  	
  	if( this.mHighlightNofollow == 0 )
  	{
  		branch.setIntPref( "highlightnofollowpref.state", 1 );
  	  this.mHighlightNofollow = 1;
  	  this.highlightNofollow( true );
  	}
  	else
  	{
  		branch.setIntPref( "highlightnofollowpref.state", 0 );
  	  this.mHighlightNofollow = 0;
  	  this.highlightNofollow( false );
  	}
  	
  	this.initGoogleStatus();
  },  	
  
  highlightNofollow: function( highlight )
  {
    const mainTabBox   = getBrowser().mTabBox;
    const documentList = this.getDocuments( getBrowser().browsers[mainTabBox.selectedIndex].contentWindow, new Array() );

		var id = "searchstatus-nofollow";
    var element      = null;
    var pageDocument = null;

    // Loop through the documents
    for(var i = 0; i < documentList.length; i++)
    {
      pageDocument = documentList[i];

      // Remove all elements with that id
      while( ( element = pageDocument.getElementById( id ) ) != null )
      {
        element.parentNode.removeChild( element );
      }
    }

		if( highlight ) 
		{
	    var headElementList = null;
	    var linkElement     = null;
	
	    // Loop through the documents
	    for( var i = 0; i < documentList.length; i++ )
	    {
	      pageDocument    = documentList[i];
	      
	      var nofollowall = false;
	      var tags = pageDocument.getElementsByTagName( "meta" );
	      for( var j = 0; j < tags.length; j++ )
				{
					var tag = tags.item( j );
					
	      	if( tag.hasAttribute( "name") && tag.getAttribute( "name" ).toLowerCase() == "robots"  && tag.hasAttribute( "content" ) && ( tag.getAttribute( "content" ).toLowerCase().indexOf( "nofollow" ) > -1 || tag.getAttribute( "content" ).toLowerCase().indexOf( "none" ) > -1 ) )
	      	{
	      		 nofollowall = true;
	      	}
	     	}
	      
	      headElementList = pageDocument.getElementsByTagName( "head" );
	      styleElement    = pageDocument.createElement( "style" );
	      styleText       = pageDocument.createTextNode( "a" + ( nofollowall ? "" : "[rel~=\"nofollow\"]" ) + " {  border: thin dashed firebrick ! important;  background-color: rgb(255, 200, 200) ! important; }" );
				styleElement.appendChild( styleText );
	
	      // If there is a head element
	      if( headElementList.length > 0 )
	      {
	        headElementList[0].appendChild( styleElement );
	      }
	      else
	      {
	        pageDocument.documentElement.appendChild( styleElement );
	      }
	    }
	  }
  },

	getDocuments: function( frame, documentList )
	{
    const framesList = frame.frames;
    documentList.push( frame.document );
    
    // Loop through the frames
    for( var i = 0; i < framesList.length; i++ )
    {
      this.getDocuments( framesList[i], documentList );
    }

    return documentList;
	},
	
	highlightSearchTerms: function( doc, searchText )
	{
	  var searchArray = [searchText,searchText.replace(/-/g, " "),searchText.replace(/ /g, "-")];
	  
	  if( !doc.body || typeof( doc.body.innerHTML ) == "undefined") 
	  {
	    return false;
	  }
	  
	  var bodyText = doc.body.innerHTML;
	  for( var i = 0; i < searchArray.length; i++ ) 
	  {
	    bodyText = this.doHighlight( bodyText, searchArray[i], this.mHighlightColours[this.mHighlightColourIndex] );
	  }
	  
	  this.mHighlightColourIndex++;
	  if( this.mHighlightColourIndex >= this.mHighlightColours.length )
	  {
	  	this.mHighlightColourIndex = 0;
	  }
	  
	  doc.body.innerHTML = bodyText;
	  
	  return true;
	},  
  
	doHighlight: function( bodyText, searchTerm, colour ) 
	{
    var highlightStartTag = "<font style='background-color: rgb(" + colour + ") ! important;'>";
	  var highlightEndTag = "</font>";
	  
	  // find all occurences of the search term in the given text,
	  // and add some "highlight" tags to them (we're not using a
	  // regular expression search, because we want to filter out
	  // matches that occur within HTML tags and script blocks, so
	  // we have to do a little extra validation)
	  var newText = "";
	  var i = -1;
	  var lcSearchTerm = searchTerm.toLowerCase();
	  var lcBodyText = bodyText.toLowerCase();
	  
		var spaceTerm = lcSearchTerm.replace( /-/g, " " );
	  var dashTerm = lcSearchTerm.replace( / /g, "-" );  
	    
	  while( bodyText.length > 0 ) 
	  {
	    i = lcBodyText.indexOf( lcSearchTerm, i + 1 );
	    
	    if( i < 0 ) 
	    {
	      newText += bodyText;
	      bodyText = "";
	    } 
	    else 
	  	{
	      // skip anything inside an HTML tag
	      if( bodyText.lastIndexOf( ">", i ) >= bodyText.lastIndexOf( "<", i ) ) 
	      {
	        // skip anything inside a <script> block
	        if( lcBodyText.lastIndexOf( "/script>", i ) >= lcBodyText.lastIndexOf( "<script", i ) ) 
	        {
	          newText += bodyText.substring( 0, i ) + highlightStartTag + bodyText.substr( i, searchTerm.length ) + highlightEndTag;
	          bodyText = bodyText.substr( i + searchTerm.length );
	          lcBodyText = bodyText.toLowerCase();
	          i = -1;
	        }
	      }
	    }
	  }
	  
	  return newText;
	}	
};

function googlechcalc()
{
  return this; 
}

googlechcalc.prototype =
{
  googleNewCh: function( ch )
  {
  	ch = ( ( ( ch / 7 ) << 2 ) | ( ( this.myfmod( ch,13 ) ) & 7 ) );
  
  	prbuf = new Array();
  	prbuf[0] = ch;
  	for( i = 1; i < 20; i++ ) 
  	{
      prbuf[i] = prbuf[i-1] - 9;
  	}
  	ch = this.googleCH( this.c32to8bit( prbuf ), 80 );
  	
  	return ch;		
  },

  googleCH: function( url ) 
  {
		var init = 0xE6359A60;
		
		var length = url.length;
		
		var a = 0x9E3779B9;
		var b = 0x9E3779B9;
		var c = 0xE6359A60;
		var k = 0;
		var len = length;
		var mixo = new Array(); 
				
		while( len >= 12 ) 
		{
			a += (url[k+0] +(url[k+1]<<8) +(url[k+2]<<16) +(url[k+3]<<24));
			b += (url[k+4] +(url[k+5]<<8) +(url[k+6]<<16) +(url[k+7]<<24));
			c += (url[k+8] +(url[k+9]<<8) +(url[k+10]<<16)+(url[k+11]<<24));
			mixo = this.mix(a,b,c);
			a = mixo[0]; b = mixo[1]; c = mixo[2];
			k += 12;
			len -= 12;
		}
		
		c += length;
		
		switch( len ) 
		{
			case 11:
			c += url[k+10]<<24;
			
			case 10: 
			c+=url[k+9]<<16;
			
			case 9 : 
			c+=url[k+8]<<8;
			
			case 8 : 
			b+=(url[k+7]<<24);
			
			case 7 : 
			b+=(url[k+6]<<16);
			
			case 6 : 
			b+=(url[k+5]<<8);
			
			case 5 : 
			b+=(url[k+4]);
			
			case 4 : 
			a+=(url[k+3]<<24);
			
			case 3 : 
			a+=(url[k+2]<<16);
			
			case 2 : 
			a+=(url[k+1]<<8);
			
			case 1 : 
			a+=(url[k+0]);
		}
		
		mixo = this.mix( a, b, c );
		
		if( mixo[2] < 0 )
		{
			return ( 0x100000000 + mixo[2] );
		}
	  else
	  {
			return mixo[2];
		}
  },

  hexdec: function( str )
  {
  	return parseInt( str, 16 );
  },
  
  zeroFill: function( a, b )
  {
  	var z = this.hexdec( 80000000 );
  	
  	if( z & a )
  	{
  		a = a >> 1;
  		a &= ~z;
  		a |= 0x40000000;
  		a = a >> ( b - 1 );
  	} 
  	else
  	{
  		a = a >> b;
  	}
  	
  	return (a);
  },
  
  mix: function( a, b, c ) 
  {
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 13 ) );
  	b -= c; b -= a; b ^= ( a << 8 );
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 13 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 12 ) );
  	b -= c; b -= a; b ^= ( a << 16);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 5 ) );
  	a -= b; a -= c; a ^= ( this.zeroFill( c, 3 ) ); 
  	b -= c; b -= a; b ^= ( a << 10);
  	c -= a; c -= b; c ^= ( this.zeroFill( b, 15 ) );
  	
  	var ret = new Array( (a), (b), (c) );
  	
  	return ret;
  },

  strord: function( string ) 
  {
  	var result = new Array();
  	for( i = 0; i < string.length; i++ ) 
  	{
  		result[i] = string[i].charCodeAt( 0 );
  	}
  	
  	return result;
  },
  
  c32to8bit: function( arr32 ) 
  {
    var arr8 = new Array();	
    
    for( i = 0; i < arr32.length; i++ ) 
    {
    	for( bitOrder = i * 4; bitOrder <= i * 4 + 3; bitOrder++ ) 
    	{
        arr8[bitOrder] = arr32[i] & 255;
        arr32[i] = this.zeroFill( arr32[i], 8 );
      }
    }
    
    return arr8;
  },
  
  myfmod: function( x, y )
  {
  	var i = Math.floor( x / y );
    return ( x - i * y );
  }
};

// Searchstatus globals

var gSearchstatus = new searchstatus();
var gSearchStatusInitialised = false;

var gGoogleCHCalc = new googlechcalc();

function searchstatusPageShow()
{
	if( !gSearchStatusInitialised )
  {
  	gSearchstatus.init();
  	gSearchStatusInitialised = true;
  }

  gSearchstatus.initStatus();
}

function searchstatusFocus()
{
  gSearchstatus.resetStatus();
}

// Events

window.addEventListener( "pageshow", function() {searchstatusPageShow();}, false );
window.addEventListener( "focus", function() {searchstatusFocus();}, true );

function onGoogleRequestLoad()
{
	gSearchstatus.setGoogleStatus();
}

function onAlexaRequestLoad()
{
	gSearchstatus.setAlexaStatus();
}

function onCompeteRequestLoad()
{
	gSearchstatus.setCompeteStatus();
}

function onIPRequestLoad()
{
	gSearchstatus.setLocalIP();
}

// General

function getRootDomain( url )
{
  var lastDot = url.lastIndexOf( '.' );
  var secondLastDot = url.lastIndexOf( '.', lastDot - 1 );
  
  if( url.substring( lastDot + 1 ).length > 2 )
  {
    if( secondLastDot > -1 && ( lastDot - secondLastDot ) > 3 )
    {
      return url.substring( secondLastDot + 1 );
    }
  }

  var thirdLastDot = url.lastIndexOf( '.', secondLastDot - 1 );
  
  if( thirdLastDot > -1 )
  {
    return url.substring( thirdLastDot + 1 );
  }
  
  return url;
}

function hideSearchStatusTooltip()
{
	document.getElementById( "searchstatus-status" ).setAttribute( "tooltip", "" );
}

function showSearchStatusTooltip()
{
	document.getElementById( "searchstatus-status" ).setAttribute( "tooltip", "searchstatus-tooltip" );
}

function showSearchStatusAbout()
{
	window.openDialog( "chrome://searchstatus/content/about.xul", "searchstatus-about-dialog", "centerscreen,chrome,modal" );
}

function showSearchStatusOptions()
{
	window.openDialog( "chrome://searchstatus/content/options.xul", "searchstatus-options-dialog", "centerscreen,chrome,modal" );
}

function ssOpenItemUrl( item )
{
	ssOpenUrl( item.value );
}

function ssOpenUrl( url )
{
  var browser = document.getElementById( "content" );
  var tab = browser.addTab( url, null );
  
	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
	var branch = preferencesService.getBranch( "extensions.searchstatus." );  
	if( branch.prefHasUserValue( "searchstatus.backgroundopen" ) && branch.getBoolPref( "searchstatus.backgroundopen" ) )
	{
		return;
	}
	
	browser.selectedTab = tab;
}

function ssUrlEncode( url ) 
{
  return escape(url).replace(/\+/g, '%2B').replace(/\"/g, '%22').replace(/\'/g, '%27');
}

function getArrayIndex( arr, hash )
{
  var i = 0;
  var found = -1;
  
  while( found == -1 && ( i < arr.length ) )
  {
    if( arr[i][0] == hash )
    {
      found = i;
      break;
    }
    
    i++;
  }
  
  return found;
}

function ssFormatInteger( integer )
{
	var pattern = "###,###,###,###";
	var result = '';

	integerIndex = integer.length - 1;
	patternIndex = pattern.length - 1;

	while( ( integerIndex >= 0 ) && ( patternIndex >= 0 ) )
	{
		var digit = integer.charAt( integerIndex );
		integerIndex--;
		
		// Skip non-digits from the source integer (eradicate current formatting).
		if( ( digit < '0' ) || ( digit > '9') )  continue;
	
		// Got a digit from the integer, now plug it into the pattern.
		while( patternIndex >= 0 )
		{
			var patternChar = pattern.charAt( patternIndex );
			patternIndex--;
			
			// Substitute digits for '#' chars, treat other chars literally.
			if( patternChar == '#' )
			{
				result = digit + result;
				break;
			}
			else
			{
				result = patternChar + result;
			}
		}
	}
	
	return result;
}

function debugss( message ) 
{
  //var time = new Date();
  //var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();
  //dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
  
  //var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  //aConsoleService.logStringMessage( "SearchStatus: " + message );
}
